MagickCore: compress.c File Reference

# compress.c File Reference

`#include "magick/studio.h"`
`#include "magick/blob.h"`
`#include "magick/blob-private.h"`
`#include "magick/color-private.h"`
`#include "magick/compress.h"`
`#include "magick/constitute.h"`
`#include "magick/exception.h"`
`#include "magick/exception-private.h"`
`#include "magick/image-private.h"`
`#include "magick/list.h"`
`#include "magick/memory_.h"`
`#include "magick/monitor.h"`
`#include "magick/option.h"`
`#include "magick/resource_.h"`
`#include "magick/string_.h"`
`#include "tiffconf.h"`
`#include "tiffio.h"`
`#include "zlib.h"`

## Data Structures
struct | _Ascii85Info
struct | HuffmanTable
## Defines
#define | CCITTParam "-1"
#define | TWId 23
#define | MWId 24
#define | TBId 25
#define | MBId 26
#define | EXId 27
#define | MaxLineExtent 36
#define | HashSize 1021
#define | MBHashA 293
#define | MBHashB 2695
#define | MWHashA 3510
#define | MWHashB 1178
#define | InitializeHashTable(hash, table, a, b)
#define | InputBit(bit)
#define | HuffmanOutputCode(entry)
#define | OutputBit(count)
#define | LZWClr 256UL
#define | LZWEod 257UL
#define | OutputCode(code)
## Functions
static char * | Ascii85Tuple (unsigned char *data)
MagickExport void | Ascii85Initialize (Image *image)
MagickExport void | Ascii85Flush (Image *image)
MagickExport void | Ascii85Encode (Image *image, const unsigned char code)
static size_t | MagickMax (const size_t x, const size_t y)
static size_t | MagickMin (const size_t x, const size_t y)
MagickExport MagickBooleanType | HuffmanDecodeImage (Image *image)
MagickExport MagickBooleanType | HuffmanEncodeImage (const ImageInfo *image_info, Image *image)
MagickExport MagickBooleanType | Huffman2DEncodeImage (const ImageInfo *image_info, Image *image)
MagickExport MagickBooleanType | LZWEncodeImage (Image *image, const size_t length, unsigned char *pixels)
MagickExport MagickBooleanType | PackbitsEncodeImage (Image *image, const size_t length, unsigned char *pixels)
MagickExport MagickBooleanType | ZLIBEncodeImage (Image *image, const size_t length, unsigned char *pixels)
## Variables
static const HuffmanTable | MBTable []
static const HuffmanTable | EXTable []
static const HuffmanTable | MWTable []
static const HuffmanTable | TBTable []
static const HuffmanTable | TWTable []

## Define Documentation

#define CCITTParam "-1"

#define EXId 27

#define HashSize 1021

#define HuffmanOutputCode | ( | entry |  | ) |

Value:

    {  \
      mask=1 << (entry->length-1);  \
      while (mask != 0)  \
      {  \
        OutputBit(((entry->code & mask) != 0 ? 1 : 0));  \
        mask>>=1;  \
      }  \
    }

#define InitializeHashTable | ( | hash,
|  | table,
|  | a,
|  | b |  | ) |

Value:

    { \
      entry=table; \
      while (entry->code != 0) \
      {  \
        hash[((entry->length+a)*(entry->code+b)) % HashSize]=(HuffmanTable *) entry; \
        entry++; \
      } \
    }

#define InputBit | ( | bit |  | ) |

Value:

    {  \
      if ((mask & 0xff) == 0)  \
        {  \
          byte=ReadBlobByte(image);  \
          if (byte == EOF)  \
            break;  \
          mask=0x80;  \
        }  \
      runlength++;  \
      bit=(unsigned long) ((byte & mask) != 0 ? 0x01 : 0x00); \
      mask>>=1;  \
      if (bit != 0)  \
        runlength=0;  \
    }

#define LZWClr 256UL

#define LZWEod 257UL

#define MaxLineExtent 36

#define MBHashA 293

#define MBHashB 2695

#define MBId 26

#define MWHashA 3510

#define MWHashB 1178

#define MWId 24

#define OutputBit | ( | count |  | ) |

Value:

    {  \
      if (count > 0)  \
        byte=byte | bit;  \
      bit>>=1;  \
      if ((int) (bit & 0xff) == 0)   \
        {  \
          if (LocaleCompare(image_info->magick,"FAX") == 0) \
            (void) WriteBlobByte(image,(unsigned char) byte);  \
          else \
            Ascii85Encode(image,byte); \
          byte='\0';  \
          bit=(unsigned char) 0x80;  \
        }  \
    }

#define OutputCode | ( | code |  | ) |

Value:

    { \
        accumulator+=code << (32-code_width-number_bits); \
        number_bits+=code_width; \
        while (number_bits >= 8) \
        { \
            (void) WriteBlobByte(image,(unsigned char) (accumulator >> 24)); \
            accumulator=accumulator << 8; \
            number_bits-=8; \
        } \
    }

#define TBId 25

#define TWId 23

## Function Documentation

MagickExport void Ascii85Encode | ( | Image * | image,
|  | const unsigned char | code |
| ) |  |  |

MagickExport void Ascii85Flush | ( | Image * | image | ) |

MagickExport void Ascii85Initialize | ( | Image * | image | ) |

static char* Ascii85Tuple | ( | unsigned char * | data | ) | `[static]`

MagickExport MagickBooleanType Huffman2DEncodeImage | ( | const ImageInfo * | image_info,
|  | Image * | image |
| ) |  |  |

MagickExport MagickBooleanType HuffmanDecodeImage | ( | Image * | image | ) |

MagickExport MagickBooleanType HuffmanEncodeImage | ( | const ImageInfo * | image_info,
|  | Image * | image |
| ) |  |  |

MagickExport MagickBooleanType LZWEncodeImage | ( | Image * | image,
|  | const size_t | length,
|  | unsigned char * | pixels |
| ) |  |  |

static size_t MagickMax | ( | const size_t | x,
|  | const size_t | y |
| ) |  |  | `[inline, static]`

static size_t MagickMin | ( | const size_t | x,
|  | const size_t | y |
| ) |  |  | `[inline, static]`

MagickExport MagickBooleanType PackbitsEncodeImage | ( | Image * | image,
|  | const size_t | length,
|  | unsigned char * | pixels |
| ) |  |  |

MagickExport MagickBooleanType ZLIBEncodeImage | ( | Image * | image,
|  | const size_t | length,
|  | unsigned char * | pixels |
| ) |  |  |

## Variable Documentation

const HuffmanTable EXTable[]`[static]`

Initial value:

      {
        { EXId, 0x08, 11, 1792 }, { EXId, 0x0c, 11, 1856 },
        { EXId, 0x0d, 11, 1920 }, { EXId, 0x12, 12, 1984 },
        { EXId, 0x13, 12, 2048 }, { EXId, 0x14, 12, 2112 },
        { EXId, 0x15, 12, 2176 }, { EXId, 0x16, 12, 2240 },
        { EXId, 0x17, 12, 2304 }, { EXId, 0x1c, 12, 2368 },
        { EXId, 0x1d, 12, 2432 }, { EXId, 0x1e, 12, 2496 },
        { EXId, 0x1f, 12, 2560 }, { EXId, 0x00, 0, 0 }
      }

const HuffmanTable MBTable[]`[static]`

Initial value:

      {
        { MBId, 0x0f, 10, 64 }, { MBId, 0xc8, 12, 128 },
        { MBId, 0xc9, 12, 192 }, { MBId, 0x5b, 12, 256 },
        { MBId, 0x33, 12, 320 }, { MBId, 0x34, 12, 384 },
        { MBId, 0x35, 12, 448 }, { MBId, 0x6c, 13, 512 },
        { MBId, 0x6d, 13, 576 }, { MBId, 0x4a, 13, 640 },
        { MBId, 0x4b, 13, 704 }, { MBId, 0x4c, 13, 768 },
        { MBId, 0x4d, 13, 832 }, { MBId, 0x72, 13, 896 },
        { MBId, 0x73, 13, 960 }, { MBId, 0x74, 13, 1024 },
        { MBId, 0x75, 13, 1088 }, { MBId, 0x76, 13, 1152 },
        { MBId, 0x77, 13, 1216 }, { MBId, 0x52, 13, 1280 },
        { MBId, 0x53, 13, 1344 }, { MBId, 0x54, 13, 1408 },
        { MBId, 0x55, 13, 1472 }, { MBId, 0x5a, 13, 1536 },
        { MBId, 0x5b, 13, 1600 }, { MBId, 0x64, 13, 1664 },
        { MBId, 0x65, 13, 1728 }, { MBId, 0x00, 0, 0 }
      }

const HuffmanTable MWTable[]`[static]`

Initial value:

      {
        { MWId, 0x1b, 5, 64 }, { MWId, 0x12, 5, 128 },
        { MWId, 0x17, 6, 192 }, { MWId, 0x37, 7, 256 },
        { MWId, 0x36, 8, 320 }, { MWId, 0x37, 8, 384 },
        { MWId, 0x64, 8, 448 }, { MWId, 0x65, 8, 512 },
        { MWId, 0x68, 8, 576 }, { MWId, 0x67, 8, 640 },
        { MWId, 0xcc, 9, 704 }, { MWId, 0xcd, 9, 768 },
        { MWId, 0xd2, 9, 832 }, { MWId, 0xd3, 9, 896 },
        { MWId, 0xd4, 9, 960 }, { MWId, 0xd5, 9, 1024 },
        { MWId, 0xd6, 9, 1088 }, { MWId, 0xd7, 9, 1152 },
        { MWId, 0xd8, 9, 1216 }, { MWId, 0xd9, 9, 1280 },
        { MWId, 0xda, 9, 1344 }, { MWId, 0xdb, 9, 1408 },
        { MWId, 0x98, 9, 1472 }, { MWId, 0x99, 9, 1536 },
        { MWId, 0x9a, 9, 1600 }, { MWId, 0x18, 6, 1664 },
        { MWId, 0x9b, 9, 1728 }, { MWId, 0x00, 0, 0 }
      }

const HuffmanTable TBTable[]`[static]`

Initial value:

      {
        { TBId, 0x37, 10, 0 }, { TBId, 0x02, 3, 1 }, { TBId, 0x03, 2, 2 },
        { TBId, 0x02, 2, 3 }, { TBId, 0x03, 3, 4 }, { TBId, 0x03, 4, 5 },
        { TBId, 0x02, 4, 6 }, { TBId, 0x03, 5, 7 }, { TBId, 0x05, 6, 8 },
        { TBId, 0x04, 6, 9 }, { TBId, 0x04, 7, 10 }, { TBId, 0x05, 7, 11 },
        { TBId, 0x07, 7, 12 }, { TBId, 0x04, 8, 13 }, { TBId, 0x07, 8, 14 },
        { TBId, 0x18, 9, 15 }, { TBId, 0x17, 10, 16 }, { TBId, 0x18, 10, 17 },
        { TBId, 0x08, 10, 18 }, { TBId, 0x67, 11, 19 }, { TBId, 0x68, 11, 20 },
        { TBId, 0x6c, 11, 21 }, { TBId, 0x37, 11, 22 }, { TBId, 0x28, 11, 23 },
        { TBId, 0x17, 11, 24 }, { TBId, 0x18, 11, 25 }, { TBId, 0xca, 12, 26 },
        { TBId, 0xcb, 12, 27 }, { TBId, 0xcc, 12, 28 }, { TBId, 0xcd, 12, 29 },
        { TBId, 0x68, 12, 30 }, { TBId, 0x69, 12, 31 }, { TBId, 0x6a, 12, 32 },
        { TBId, 0x6b, 12, 33 }, { TBId, 0xd2, 12, 34 }, { TBId, 0xd3, 12, 35 },
        { TBId, 0xd4, 12, 36 }, { TBId, 0xd5, 12, 37 }, { TBId, 0xd6, 12, 38 },
        { TBId, 0xd7, 12, 39 }, { TBId, 0x6c, 12, 40 }, { TBId, 0x6d, 12, 41 },
        { TBId, 0xda, 12, 42 }, { TBId, 0xdb, 12, 43 }, { TBId, 0x54, 12, 44 },
        { TBId, 0x55, 12, 45 }, { TBId, 0x56, 12, 46 }, { TBId, 0x57, 12, 47 },
        { TBId, 0x64, 12, 48 }, { TBId, 0x65, 12, 49 }, { TBId, 0x52, 12, 50 },
        { TBId, 0x53, 12, 51 }, { TBId, 0x24, 12, 52 }, { TBId, 0x37, 12, 53 },
        { TBId, 0x38, 12, 54 }, { TBId, 0x27, 12, 55 }, { TBId, 0x28, 12, 56 },
        { TBId, 0x58, 12, 57 }, { TBId, 0x59, 12, 58 }, { TBId, 0x2b, 12, 59 },
        { TBId, 0x2c, 12, 60 }, { TBId, 0x5a, 12, 61 }, { TBId, 0x66, 12, 62 },
        { TBId, 0x67, 12, 63 }, { TBId, 0x00, 0, 0 }
      }

const HuffmanTable TWTable[]`[static]`

Initial value:

      {
        { TWId, 0x35, 8, 0 }, { TWId, 0x07, 6, 1 }, { TWId, 0x07, 4, 2 },
        { TWId, 0x08, 4, 3 }, { TWId, 0x0b, 4, 4 }, { TWId, 0x0c, 4, 5 },
        { TWId, 0x0e, 4, 6 }, { TWId, 0x0f, 4, 7 }, { TWId, 0x13, 5, 8 },
        { TWId, 0x14, 5, 9 }, { TWId, 0x07, 5, 10 }, { TWId, 0x08, 5, 11 },
        { TWId, 0x08, 6, 12 }, { TWId, 0x03, 6, 13 }, { TWId, 0x34, 6, 14 },
        { TWId, 0x35, 6, 15 }, { TWId, 0x2a, 6, 16 }, { TWId, 0x2b, 6, 17 },
        { TWId, 0x27, 7, 18 }, { TWId, 0x0c, 7, 19 }, { TWId, 0x08, 7, 20 },
        { TWId, 0x17, 7, 21 }, { TWId, 0x03, 7, 22 }, { TWId, 0x04, 7, 23 },
        { TWId, 0x28, 7, 24 }, { TWId, 0x2b, 7, 25 }, { TWId, 0x13, 7, 26 },
        { TWId, 0x24, 7, 27 }, { TWId, 0x18, 7, 28 }, { TWId, 0x02, 8, 29 },
        { TWId, 0x03, 8, 30 }, { TWId, 0x1a, 8, 31 }, { TWId, 0x1b, 8, 32 },
        { TWId, 0x12, 8, 33 }, { TWId, 0x13, 8, 34 }, { TWId, 0x14, 8, 35 },
        { TWId, 0x15, 8, 36 }, { TWId, 0x16, 8, 37 }, { TWId, 0x17, 8, 38 },
        { TWId, 0x28, 8, 39 }, { TWId, 0x29, 8, 40 }, { TWId, 0x2a, 8, 41 },
        { TWId, 0x2b, 8, 42 }, { TWId, 0x2c, 8, 43 }, { TWId, 0x2d, 8, 44 },
        { TWId, 0x04, 8, 45 }, { TWId, 0x05, 8, 46 }, { TWId, 0x0a, 8, 47 },
        { TWId, 0x0b, 8, 48 }, { TWId, 0x52, 8, 49 }, { TWId, 0x53, 8, 50 },
        { TWId, 0x54, 8, 51 }, { TWId, 0x55, 8, 52 }, { TWId, 0x24, 8, 53 },
        { TWId, 0x25, 8, 54 }, { TWId, 0x58, 8, 55 }, { TWId, 0x59, 8, 56 },
        { TWId, 0x5a, 8, 57 }, { TWId, 0x5b, 8, 58 }, { TWId, 0x4a, 8, 59 },
        { TWId, 0x4b, 8, 60 }, { TWId, 0x32, 8, 61 }, { TWId, 0x33, 8, 62 },
        { TWId, 0x34, 8, 63 }, { TWId, 0x00, 0, 0 }
      }